-- $Id: PolynomialsTests.hs,v 1.1 2013/08/18 16:35:26 leavens Exp $
module PolynomialsTests where
import Testing
import FloatTesting
import Polynomials  -- you have to put your solutions in module Polynomials
version = "PolynomialsTests $Revision: 1.1 $"
-- do main to run our tests
main :: IO()
main = do startTesting version
          errs_scaleBy <- run_test_list 0 scaleBy_tests
          errs_add <- run_test_list errs_scaleBy add_tests
          total_errs <- run_test_list errs_add sub_tests
          doneTesting total_errs
-- The following will test one function each
test_scaleBy, test_add, test_sub :: IO()
test_scaleBy = dotests "Testing scaleBy $Revision: 1.1 $" scaleBy_tests 
test_add = dotests "Testing add $Revision: 1.1 $" add_tests 
test_sub = dotests "Testing sub $Revision: 1.1 $" sub_tests 

scaleBy_tests :: [TestCase Polynomial]
scaleBy_tests = 
    [(vecWithin (scaleBy 3.14 []) "~=~" [])
    ,(vecWithin (scaleBy 10.0 [1.0, 2.0, 4.0]) "~=~" [10.0, 20.0, 40.0])
    ,(vecWithin (scaleBy 5.3 [1.0 .. 10.0]) "~=~" [5.3, 10.6 .. 53.0])
    ,(vecWithin (scaleBy 2.0 [1.0 .. 100.0]) "~=~" [2.0, 4.0 .. 200.0])
    ,(vecWithin (scaleBy 3.5 [4.0]) "~=~" [3.5*4.0])
    ]
add_tests :: [TestCase Polynomial]
add_tests = 
    [(vecWithin ([] `add` []) "~=~" [])
    ,(vecWithin ([0.0, 100.0, 200.0] `add` [1.0, 2.0, 4.0])
                    "~=~" [1.0, 102.0, 204.0])
    ,(vecWithin ([1.0 .. 10.0] `add` [100.0 .. 109.0]) 
                    "~=~" [101.0, 103.0 .. 119.0])
    ,(vecWithin ([1.0 .. 10.0] `add` [1.0 .. 110.0]) 
                    "~=~" ([2.0, 4.0 .. 20.0] ++ [11.0 .. 110.0]))
    ,(vecWithin ([3.5] `add` []) "~=~" [3.5])
    ,(vecWithin ([3.5] `add` [7.2,9.6,13.1,15.5]) "~=~" [10.7,9.6,13.1,15.5])
    ,(vecWithin ([] `add` [40.20]) "~=~" [40.20])
    ]
sub_tests :: [TestCase Polynomial]
sub_tests = 
    [(vecWithin ([] `sub` []) "~=~" [])
    ,(vecWithin ([0.0, 100.0, 200.0] `sub` [1.0, 2.0, 4.0])
                    "~=~" [-1.0, 98.0, 196.0])
    ,(vecWithin ([1.0 .. 10.0] `sub` [100.0 .. 109.0]) 
                    "~=~" (take 10 [-99.0, -99.0 ..]))
    ,(vecWithin ([1.0 .. 10.0] `sub` [1.0 .. 110.0]) 
                    "~=~" ((take 10 [0.0, 0.0 ..]) ++ [-11.0, -12.0 .. -110.0]))
    ,(vecWithin ([3.5] `sub` []) "~=~" [3.5])
    ,(vecWithin ([3.5] `sub` [7.2,9.6,13.1,15.5]) "~=~" [-3.7,-9.6,-13.1,-15.5])
    ,(vecWithin ([] `sub` [40.20]) "~=~" [-40.20])
    ]
